//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3635EFE100BA.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3635EFE100BA.cm

//## begin module%3635EFE100BA.cp preserve=no
//## end module%3635EFE100BA.cp

//## Module: Response%3635EFE100BA; Package body
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/Detector/Response.cxx

//## begin module%3635EFE100BA.additionalIncludes preserve=no
//## end module%3635EFE100BA.additionalIncludes

//## begin module%3635EFE100BA.includes preserve=yes
//## end module%3635EFE100BA.includes

// Model
#include <XSModel/Model/Model.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// ResponseParam
#include <XSModel/Parameter/ResponseParam.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// Response
#include <XSModel/Data/Detector/Response.h>


//## begin module%3635EFE100BA.declarations preserve=no
//## end module%3635EFE100BA.declarations

//## begin module%3635EFE100BA.additionalDeclarations preserve=yes
#include <XSsymbol.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/GlobalContainer/ResponseContainer.h>
#include <XSModel/Parameter/ParamLinkList.h>
#include <limits>
//## end module%3635EFE100BA.additionalDeclarations


// Class Response::InvalidBins 

Response::InvalidBins::InvalidBins (const string& message)
  //## begin Response::InvalidBins::InvalidBins%37FE3ADDB1D8.hasinit preserve=yes
  : YellowAlert(" invalid bins - ")
  //## end Response::InvalidBins::InvalidBins%37FE3ADDB1D8.hasinit
  //## begin Response::InvalidBins::InvalidBins%37FE3ADDB1D8.initialization preserve=yes
  //## end Response::InvalidBins::InvalidBins%37FE3ADDB1D8.initialization
{
  //## begin Response::InvalidBins::InvalidBins%37FE3ADDB1D8.body preserve=yes
    tcerr << message << std::endl;
  //## end Response::InvalidBins::InvalidBins%37FE3ADDB1D8.body
}


// Class Response::InvalidRequest 

Response::InvalidRequest::InvalidRequest()
  //## begin InvalidRequest::InvalidRequest%3CF632C001F7_const.initialization preserve=yes
  : YellowAlert(" request not supported by this  response type.\n")
  //## end InvalidRequest::InvalidRequest%3CF632C001F7_const.initialization
{
  //## begin Response::InvalidRequest::InvalidRequest%3CF632C001F7_const.body preserve=yes
  //## end Response::InvalidRequest::InvalidRequest%3CF632C001F7_const.body
}


// Class Response::GainError 

Response::GainError::GainError (const string& msg)
  //## begin Response::GainError::GainError%414211A60105.hasinit preserve=yes
  : YellowAlert(" Gain setting error.\n")
  //## end Response::GainError::GainError%414211A60105.hasinit
  //## begin Response::GainError::GainError%414211A60105.initialization preserve=yes
  //## end Response::GainError::GainError%414211A60105.initialization
{
  //## begin Response::GainError::GainError%414211A60105.body preserve=yes
  tcerr << msg << std::endl;
  //## end Response::GainError::GainError%414211A60105.body
}


// Class Response 

//## begin Response::count%373B0D17A528.attr preserve=no  private: static int {V} 0
int Response::s_count = 0;
//## end Response::count%373B0D17A528.attr

//## begin Response::NO_KEYVAL%4A393ED80211.attr preserve=no  public: static Real {UC} std::numeric_limits<Real>::min()
const Real Response::s_NO_KEYVAL = std::numeric_limits<Real>::min();
//## end Response::NO_KEYVAL%4A393ED80211.attr

Response::Response()
  //## begin Response::Response%362CB3EC00F4_const.hasinit preserve=yes
      : m_numEnergies(0),m_numChannels(0),m_spectrumNumber(0),
        m_sourceNumber(1),
        m_dataGroup(0),m_index(s_count++),m_eboundsExtName(""),m_active(true),
        m_constGain(0), m_linearGain(0),
        m_slopeKeyLimits(s_NO_KEYVAL,s_NO_KEYVAL),
        m_offsetKeyLimits(s_NO_KEYVAL,s_NO_KEYVAL), 
        m_energies(), m_gainFactor(2)
  //## end Response::Response%362CB3EC00F4_const.hasinit
  //## begin Response::Response%362CB3EC00F4_const.initialization preserve=yes
  //## end Response::Response%362CB3EC00F4_const.initialization
{
  //## begin Response::Response%362CB3EC00F4_const.body preserve=yes
  m_gainFactor[0] = .0;
  m_gainFactor[1] = 1.0;
  //## end Response::Response%362CB3EC00F4_const.body
}

Response::Response(const Response &right)
  //## begin Response::Response%362CB3EC00F4_copy.hasinit preserve=yes
      : m_numEnergies(right.m_numEnergies),
        m_numChannels(right.m_numChannels),
        m_spectrumNumber(right.m_spectrumNumber),
        m_sourceNumber(right.m_sourceNumber),
        m_dataGroup(right.m_dataGroup),
        m_index(s_count++),
	m_eboundsExtName(right.m_eboundsExtName),
        m_active(right.m_active),
        m_constGain(0), // Owning pointers, need deep copies made below.
        m_linearGain(0),
        m_slopeKeyLimits(right.m_slopeKeyLimits),
        m_offsetKeyLimits(right.m_offsetKeyLimits),
        m_energies(right.m_energies),
        m_gainFactor(right.m_gainFactor)
  //## end Response::Response%362CB3EC00F4_copy.hasinit
  //## begin Response::Response%362CB3EC00F4_copy.initialization preserve=yes
  //## end Response::Response%362CB3EC00F4_copy.initialization
{
  //## begin Response::Response%362CB3EC00F4_copy.body preserve=yes
  if (right.m_constGain) m_constGain = right.m_constGain->clone();
  if (right.m_linearGain) m_linearGain = right.m_linearGain->clone();
  //## end Response::Response%362CB3EC00F4_copy.body
}


Response::~Response()
{
  //## begin Response::~Response%362CB3EC00F4_dest.body preserve=yes
  removeGainParams();
  //## end Response::~Response%362CB3EC00F4_dest.body
}



//## Other Operations (implementation)
void Response::renumber (size_t newIndex)
{
  //## begin Response::renumber%3A75E0E3019E.body preserve=yes
  m_spectrumNumber = newIndex;
  //## end Response::renumber%3A75E0E3019E.body
}

bool Response::fileFormat (const string& fileName, XspecDataIO::DataType type)
{
  //## begin Response::fileFormat%3ACDCDDC02F1.body preserve=yes
  //## end Response::fileFormat%3ACDCDDC02F1.body

  return false;
}

void Response::checkRMFdata () throw ()
{
  //## begin Response::checkRMFdata%3B9012A903C0.body preserve=yes
        // this would look a little less pointless if there wasn't
        // an empty base class default implementation.
        
        RMFremove();
  //## end Response::checkRMFdata%3B9012A903C0.body
}

RealArray Response::sensitivity (const SpectralData* data)
{
  //## begin Response::sensitivity%3DE51A1C00CB.body preserve=yes
  throw InvalidRequest();
  //## end Response::sensitivity%3DE51A1C00CB.body
}

void Response::RMFremove ()
{
  //## begin Response::RMFremove%3B9012EE024B.body preserve=yes
  //## end Response::RMFremove%3B9012EE024B.body
}

bool Response::order (const Response& right) const
{
  //## begin Response::order%3B94E8A10032.body preserve=yes
  return true;
  //## end Response::order%3B94E8A10032.body
}

const RealArray& Response::lowerBoundNominalEnergy () const
{
  //## begin Response::lowerBoundNominalEnergy%3BDDBD53030F.body preserve=yes
  return eboundsMin();
  //## end Response::lowerBoundNominalEnergy%3BDDBD53030F.body
}

const RealArray& Response::upperBoundNominalEnergy () const
{
  //## begin Response::upperBoundNominalEnergy%3BDDBDAE02EF.body preserve=yes
  return eboundsMax();
  //## end Response::upperBoundNominalEnergy%3BDDBDAE02EF.body
}

const RealArray& Response::eboundsMin () const
{
  //## begin Response::eboundsMin%3BDDBDC501EC.body preserve=yes
  //## end Response::eboundsMin%3BDDBDC501EC.body

  return m_energies;
}

const RealArray& Response::eboundsMax () const
{
  //## begin Response::eboundsMax%3BDDBE100216.body preserve=yes
  //## end Response::eboundsMax%3BDDBE100216.body

  return m_energies;
}

void Response::convolve (const RealArray& flux, const RealArray& fluxErr, RealArray& foldFlux, RealArray& foldFluxErr) const
{
  //## begin Response::convolve%3C3F11A603D0.body preserve=yes
  //## end Response::convolve%3C3F11A603D0.body
}

void Response::prepareForFit ()
{
  //## begin Response::prepareForFit%3C3F13FE019A.body preserve=yes
  //## end Response::prepareForFit%3C3F13FE019A.body
}

const RealArray& Response::efficiency () const
{
  //## begin Response::efficiency%3CF63266030C.body preserve=yes
  throw InvalidRequest();
  //## end Response::efficiency%3CF63266030C.body
}

void Response::setActive (bool activeStatus)
{
  //## begin Response::setActive%3F85C0810128.body preserve=yes
  m_active = activeStatus;
  //## end Response::setActive%3F85C0810128.body
}

void Response::applyGainFromPrompt (Real slope, Real intercept)
{
  //## begin Response::applyGainFromPrompt%413DEF0302D3.body preserve=yes
  // Perhaps this isn't possible by this point.  Still 
  // worth checking ...
  if (!m_energies.size())
  {
     throw GainError("Response contains no energy bins.");
  }
  RealArray oldEnergies(m_energies);
  std::vector<Real> oldGainFactor(m_gainFactor);
  // shiftEffectiveArea function, called below, will only work
  // properly if m_energies has its no-gain value at the time
  // of the call, which is in-synch with m_savedEffectiveArea.
  if (isGainApplied())
  {
     // Undo previous gain
     m_energies += m_gainFactor[0];
     m_energies *= m_gainFactor[1];
  }
  RealArray newEnergies(m_energies);
  m_gainFactor[1] = slope;
  m_gainFactor[0] = intercept;  
  newEnergies /= m_gainFactor[1];
  newEnergies -= m_gainFactor[0];
  try
  {
     // Check for negative energy, assume newEnergies[0] is lowest.
     if (newEnergies[0] < .0)
     {
        string msg("This gain will make negative energies.");
        msg += "\n***You probably have too large an offset.";
        throw GainError(msg);
     }
     shiftEffectiveArea(newEnergies);
  }
  catch (...)
  {
     m_gainFactor = oldGainFactor;
     m_energies = oldEnergies;
     if (m_linearGain)
     {  
        m_linearGain->isPrompt(true);
        m_linearGain->setValue(oldGainFactor[1]);
        m_linearGain->isPrompt(false);
     }
     if (m_constGain)  
     {
        m_constGain->isPrompt(true);
        m_constGain->setValue(oldGainFactor[0]);
        m_constGain->isPrompt(false);
     }
     throw;
  }
  m_energies = newEnergies;
  if (m_linearGain)  
  {
     m_linearGain->isPrompt(true);
     m_linearGain->setValue(slope);
     m_linearGain->isPrompt(false);
     ParamLinkList::Instance()->updateResponseParamLinkers(m_linearGain);
  }
  if (m_constGain)  
  {
     m_constGain->isPrompt(true);
     m_constGain->setValue(intercept);
     m_constGain->isPrompt(false);
     ParamLinkList::Instance()->updateResponseParamLinkers(m_constGain);
  }
  //## end Response::applyGainFromPrompt%413DEF0302D3.body
}

void Response::removeGain ()
{
  //## begin Response::removeGain%413DEF5C0109.body preserve=yes
  removeGainParams();
  if (isGainApplied())
  {
     m_energies += m_gainFactor[0];
     m_energies *= m_gainFactor[1];
     m_gainFactor[1] = 1.0;
     m_gainFactor[0] = 0.0;
     restoreEffectiveArea();
  }
  //## end Response::removeGain%413DEF5C0109.body
}

bool Response::isGainApplied () const
{
  //## begin Response::isGainApplied%413F498E0225.body preserve=yes
  const Real FUZZ=1.0e-16;
  return (fabs(m_gainFactor[1]-1.0) > FUZZ || fabs(m_gainFactor[0]) > SMALL);
  //## end Response::isGainApplied%413F498E0225.body
}

void Response::shiftEffectiveArea (const RealArray& newEnergies)
{
  //## begin Response::shiftEffectiveArea%4140787A029A.body preserve=yes
  //## end Response::shiftEffectiveArea%4140787A029A.body
}

void Response::restoreEffectiveArea ()
{
  //## begin Response::restoreEffectiveArea%414091E502AD.body preserve=yes
  //## end Response::restoreEffectiveArea%414091E502AD.body
}

bool Response::makeGainParams (const string& slopeParamVals, const string& offsetParamVals)
{
  //## begin Response::makeGainParams%414AFE88008F.body preserve=yes
  bool deletionOccurred = false;
  
  // If one gain fit parameter already exists, then both must.
  if (m_constGain)
  {
     XSContainer::responses->removeFromRespParContainer(this, 0, 2);
     delete m_constGain;
     m_constGain = 0;
     delete m_linearGain;
     m_linearGain = 0;
     deletionOccurred = true;
  }
  
  // These constructors may throw, and we CANNOT leave here if
  // one has been created without the other.  Calling functions must
  // be able to assume that unless this function has properly returned,
  // neither parameter exists and nothing has been entered into 
  // the global parameter map.
  m_constGain = new ResponseParam(offsetParamVals, this, OFFSET);
  if (m_offsetKeyLimits.first != NO_KEYVAL())
  {
     m_constGain->setValue(m_offsetKeyLimits.first,'l');
     m_constGain->setValue(m_offsetKeyLimits.first,'b');
  }
  if (m_offsetKeyLimits.second != NO_KEYVAL())
  {
     m_constGain->setValue(m_offsetKeyLimits.second,'h');
     m_constGain->setValue(m_offsetKeyLimits.second,'t');
  }
  try
  {
     m_linearGain = new ResponseParam(slopeParamVals, this, LINEAR);
     if (m_slopeKeyLimits.first != NO_KEYVAL())
     {
        m_linearGain->setValue(m_slopeKeyLimits.first,'l');
        m_linearGain->setValue(m_slopeKeyLimits.first,'b');
     }
     if (m_slopeKeyLimits.second != NO_KEYVAL())
     {
        m_linearGain->setValue(m_slopeKeyLimits.second,'h');
        m_linearGain->setValue(m_slopeKeyLimits.second,'t');
     }
  }
  catch (...)
  {
     delete m_constGain;
     m_constGain = 0;
     throw;
  }
  
  std::vector<ResponseParam*> parsToAdd;
  parsToAdd.push_back(m_linearGain);
  parsToAdd.push_back(m_constGain);
  XSContainer::responses->addToRespParContainer(this, 0, parsToAdd); 
  
  return deletionOccurred;
  //## end Response::makeGainParams%414AFE88008F.body
}

void Response::removeGainParams ()
{
  //## begin Response::removeGainParams%414B01530218.body preserve=yes
  
  // Again, either both or neither of these parameters exist 
  // and are in the global container.
  
  if (m_constGain)
  {
     XSContainer::responses->removeFromRespParContainer(this, 0, 2);     
     delete m_constGain;
     m_constGain = 0;
     delete m_linearGain;
     m_linearGain = 0;
  }
  //## end Response::removeGainParams%414B01530218.body
}

string Response::makeParamPromptString () const
{
  //## begin Response::makeParamPromptString%414EE8520071.body preserve=yes
  std::ostringstream respString;
  respString << "Resp source_" << m_sourceNumber << "_spec_"
             << m_spectrumNumber << ": ";
  return respString.str();
  //## end Response::makeParamPromptString%414EE8520071.body
}

void Response::promptParamValues (string& paramVals, Response::ResponseParType parType) const
{
  //## begin Response::promptParamValues%414EE91C0186.body preserve=yes
  // Assumes only two parTypes for now...
  ResponseParam* pGain = (parType == LINEAR) ? m_linearGain : m_constGain;
  if (pGain)
  {
     pGain->rePrompt(paramVals);
  }
  //## end Response::promptParamValues%414EE91C0186.body
}

void Response::setParamValues (const string& paramVals, Response::ResponseParType parType)
{
  //## begin Response::setParamValues%415091DA0204.body preserve=yes
  // Assumes only two parTypes for now...
  ResponseParam* pGain = (parType == LINEAR) ? m_linearGain : m_constGain;
  if (!pGain)
  {
     throw GainError("Attempted to set values for non-existent response parameter.");
  }
  pGain->setValuesFromString(paramVals);
  //## end Response::setParamValues%415091DA0204.body
}

void Response::applyGainFromFit (Response::ResponseParType parType)
{
  //## begin Response::applyGainFromFit%4154924902F3.body preserve=yes
  // If we're here, this should mean one of the response params
  // has just been reset and is notifying Response parent to
  // reapply the corresponding gain.
  RealArray oldEnergies(m_energies);
  std::vector<Real> oldGainFactor(m_gainFactor);
  // NOTE: Unlike applyGainFromPrompt, we don't test for negative
  // energies, which might pop up here during intermediate stages
  // of a fit.  The shiftEffectiveArea function though is still
  // capable of throwing, if new energies do not overlap the
  // previous ones at all.  If this happens, we must set the
  // response params back to their old values to keep things in 
  // a consistent state.
  m_energies += m_gainFactor[0];
  m_energies *= m_gainFactor[1];
  RealArray newEnergies(m_energies);
  try
  {
     if (parType == LINEAR)
     {        
        m_gainFactor[1] = m_linearGain->value();        
     }
     else if (parType == OFFSET)
     {
        m_gainFactor[0] = m_constGain->value();
     }
     newEnergies /= m_gainFactor[1];
     newEnergies -= m_gainFactor[0];
     shiftEffectiveArea(newEnergies);
     if (tpout.logChatterLevel() >= 30)
     {
        tcout << "\nGain adjust:  Previous energies     New energies" << std::endl;
        for (size_t i=0; i<m_energies.size(); ++i)
        {
           tcout << i << "  "<<oldEnergies[i] << "    " << newEnergies[i] <<std::endl;
        }
     }
  }
  catch (...)
  {
     m_gainFactor = oldGainFactor;
     m_energies = oldEnergies;
     if (parType == LINEAR)
     {
        // To prevent setValue from calling back to this function
        // and getting infinite recursion...
        m_linearGain->isPrompt(true);
        m_linearGain->setValue(oldGainFactor[1],'v');
        m_linearGain->isPrompt(false);
     }
     else if (parType == OFFSET)
     {
        m_constGain->isPrompt(true);
        m_constGain->setValue(oldGainFactor[0],'v');
        m_constGain->isPrompt(false);
     }
     throw;
  }   
  m_energies = newEnergies;
  ParamLinkList::Instance()->updateResponseParamLinkers(parType == LINEAR ?
                m_linearGain : m_constGain);
  
  // Don't assume models container even exists.  This function may be
  // called during shut-down if a response parameter link is being
  // removed.
  if (XSContainer::models)
  {
     Model* affectedModel = XSContainer::models->lookup(this);
     if (affectedModel)
     {
        affectedModel->updateNewGainFromFit(this);
        affectedModel->fillEnergyContainer();
     }
  }
  //## end Response::applyGainFromFit%4154924902F3.body
}

void Response::makeDerivative (Real delta, RealArray& deriv, Response::ResponseParType parType)
{
  //## begin Response::makeDerivative%415B0CE80192.body preserve=yes
  //## end Response::makeDerivative%415B0CE80192.body
}

void Response::calcEffAreaPerChan (RealArray& effArea)
{
  //## begin Response::calcEffAreaPerChan%42136AA10355.body preserve=yes
   throw InvalidRequest();
  //## end Response::calcEffAreaPerChan%42136AA10355.body
}

void Response::untieParamLinks () const
{
  //## begin Response::untieParamLinks%49C40DFC0296.body preserve=yes
   // untie function does nothing if parameter is not linked.
   if (m_constGain)
      m_constGain->untie(true);
   if (m_linearGain)
      m_linearGain->untie(true);
  //## end Response::untieParamLinks%49C40DFC0296.body
}

void Response::registerResponseParams () const
{
  //## begin Response::registerResponseParams%49E8C69E03BD.body preserve=yes
   // For now response parameters are limited to gain parameters.
   // If one exists then both do.
   if (m_constGain)
   {
      std::vector<ResponseParam*> parsToAdd;
      parsToAdd.push_back(m_linearGain);
      parsToAdd.push_back(m_constGain);
      XSContainer::responses->addToRespParContainer(this, 0, parsToAdd); 
   }
  //## end Response::registerResponseParams%49E8C69E03BD.body
}

void Response::deregisterResponseParams () const
{
  //## begin Response::deregisterResponseParams%49E8C88F02BF.body preserve=yes
   if (m_constGain)
   {
     XSContainer::responses->removeFromRespParContainer(this, 0, 2); 
     untieParamLinks();    
   }
  //## end Response::deregisterResponseParams%49E8C88F02BF.body
}

// Additional Declarations
  //## begin Response%362CB3EC00F4.declarations preserve=yes
  void gSwap (Response& left, Response& right)
  {
          std::swap(left.m_numEnergies,right.m_numEnergies);
          std::swap(left.m_numChannels,right.m_numChannels);
          std::swap(left.m_spectrumNumber,right.m_spectrumNumber);
          std::swap(left.m_sourceNumber,right.m_sourceNumber);         
          std::swap(left.m_dataGroup,right.m_dataGroup);          
          std::swap(left.m_energies,right.m_energies);          
          std::swap(left.m_index,right.m_index); 
          std::swap(left.m_eboundsExtName,right.m_eboundsExtName);
          std::swap(left.m_active,right.m_active);
          std::swap(left.m_energies,right.m_energies);
          std::swap(left.m_gainFactor,right.m_gainFactor);
          std::swap(left.m_constGain,right.m_constGain);
          std::swap(left.m_linearGain,right.m_linearGain);
          std::swap(left.m_slopeKeyLimits,right.m_slopeKeyLimits);
          std::swap(left.m_offsetKeyLimits,right.m_offsetKeyLimits);
  }
  //## end Response%362CB3EC00F4.declarations
//## begin module%3635EFE100BA.epilog preserve=yes
//## end module%3635EFE100BA.epilog
